﻿using EnvelopeCreatorProject.DocusignAPI;
using EnvelopeCreatorProject.DocusignAPI.RecipientType;

namespace EnvelopeCreatorProject.Models.Recipients.RecipientTypeBuilders
{
    internal class IntermediariesBuilder : RecipientTypeBuilder
    {
        protected override string GetData(Recipient recipient)
        {
            return string.Format(
                    "{{{0}email{0}:{0}{1}{0},{0}name{0}:{0}{2}{0},{0}inheritEmailNotificationConfiguration{0}:{0}{3}{0},{0}canEditRecipientEmails{0}:{0}{4}{0},{0}canEditRecipientNames{0}:{0}{5}{0},{6}}}",
                    "\"",
                    recipient.Email,
                    recipient.UserName,
                    recipient.InheritEmailNotificationConfiguration,
                    ((Intermediary)recipient.RecipientType).CanEditEmail,
                    ((Intermediary)recipient.RecipientType).CanEditName,
                    GetRecipientCommonInfo(recipient)
                    );
        }

        internal override string GetRecipientsData()
        {
            return "\"intermediaries\":[" + base.GetRecipientsData() + "]";
        }
    }
}
