﻿using System.Collections.Generic;
using EnvelopeCreator.DocusignAPI;
using EnvelopeCreatorProject.DocusignAPI;

namespace EnvelopeCreatorProject.Models.Recipients.RecipientTypeBuilders
{
    internal class SignHereSignerBuilder : SignerRecipientsBuilder
    {
        internal SignHereSignerBuilder(
            List<Tab> signHereTabs, 
            List<Tab> initialsTabs, 
            List<Tab> dataSignFields,
            List<HtmlTab> textTabs,
            List<HtmlTab> checkboxTabs,
            List<RadioGroupTab> radioGroupTabs)
            : base(signHereTabs, initialsTabs, dataSignFields, textTabs, checkboxTabs, radioGroupTabs) { }

        protected override string GetData(Recipient recipient)
        {
            return string.Format("{{{0}email{0}:{0}{1}{0},{0}name{0}:{0}{2}{0},{3},{4},{5}}}",
            "\"",
            recipient.Email,
            recipient.UserName,
            GetRecipientCommonInfo(recipient),
            GetSignatureInfoTo(recipient),
            GetSignTabs(recipient)           
            );
        }

         internal override string GetRecipientsData(){
             return "\"signers\":[" + base.GetRecipientsData() + "]"; 
         }
        
    }
}
